/***************************************************************************
                          gnushare.h  -  description
                             -------------------
    begin                : Wed May 30 2001
    copyright            : (C) 2001 by
    email                : maksik@gmx.co.uk
 ***************************************************************************/

// the original version of this file was taken from Gnucleus (http://gnucleus.sourceforge.net)

#if !defined(__GNUSHARE_H_INCLUDED__)
#define __GNUSHARE_H_INCLUDED__

#include "mthread.h"

class MGnuDirector;

class MGnuShare  
{
friend class MShareThread;
public:
	MGnuShare(MGnuDirector*);
	virtual ~MGnuShare();

	void InitShare();
	void CloseShare();
	void ResetDirectories(DWORD &, LPHANDLE);

	//void StopShare(DWORD);
	//void ShareMessage(DWORD, WPARAM);
	void AppendQuery(QueryComp* pCompare);
	void Rescan();

	CString GetPath(DWORD);
	CString GetRandString(CString);
	//bool    GetFile(DWORD, CString&, int*, bool);
	bool    GetFile(DWORD, CString&, CString&, bool);
	void    GetShareCopy(std::vector<SharedFile>&);

	//std::vector<CString> DirList;	// Shared directories
	//std::vector<DWORD>   DirSize;	// Total size of contents of each directory
	//std::vector<DWORD>   DirCount;	// Total count of files in each directory

	DWORD m_dwEstFileCount;
	DWORD m_dwTotalFiles;
	DWORD m_dwTotalSize;

protected:
	MGnuDirector* m_pDirector;

private:
	MShareThread* m_pSearchSharedThread;
	
	MGnuShare();                       // no implementation
	MGnuShare(const MGnuShare& rSrc);  // no implementation
};

#endif // __GNUSHARE_H_INCLUDED__
